// (c) 2000 Richard Grimes, iDevResource.com Ltd
// you are free to use this code as long as your copyright message
// acknowledges iDevResource.com Ltd

#include "StdAfx.h"
#include "DebugInfoView.h"
#include "MainFrm.h"

// this is wizard generated code
BOOL CMainFrame::PreTranslateMessage(MSG* pMsg)
{
	return IsDialogMessage(pMsg);
}

// this is used so that the UI elements are updated when the process is idle
BOOL CMainFrame::OnIdle()
{
   UpdateUIAll();
	return FALSE;
}

// show the about box
LRESULT CMainFrame::OnAppAbout(WORD, WORD, HWND, BOOL&)
{
	CAboutDlg dlg;
	dlg.DoModal();
	return 0;
}

// the process is going away...
LRESULT CMainFrame::OnExit(WORD, WORD, HWND, BOOL&)
{
   PostMessage(WM_CLOSE);
   return 0;
}

// the process is going away...
LRESULT CMainFrame::OnClose()
{
//   m_view.SendMessage(WM_CLOSE);
   DestroyWindow();
	::PostQuitMessage(0);
	return 0;
}

// this is called to clear all the data in the process and start again
LRESULT CMainFrame::OnClearAll(WORD, WORD, HWND, BOOL&)
{
   m_view.SendMessage(WM_COMMAND, MAKEWPARAM(ID_VIEW_CLEARALL, 0), NULL);
   return 0;
}

// the user has indicated that a process should be debugged
LRESULT CMainFrame::OnStartProcess(WORD, WORD, HWND, BOOL&)
{
   CFileDialog ofn(TRUE, _T("exe"), NULL, 
      OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST, 
      _T("Processes\0*.exe\0All Files\0*.*\0"), this->m_hWnd);   
   ofn.m_ofn.lpstrTitle = _T("Select the executable to start");

   // find which process to start
   if (ofn.DoModal() == IDOK)
   {
      // get view to do the work
      m_view.StartProcess(ofn.m_szFileName);
   }
   return 0;
}

// the user wants to see saved results
LRESULT CMainFrame::OnOpenResults(WORD, WORD, HWND, BOOL&)
{
   CFileDialog ofn(TRUE, _T("txt"), NULL, 
      OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST, 
      _T("Results\0*.txt\0All Files\0*.*\0"), this->m_hWnd);   
   ofn.m_ofn.lpstrTitle = _T("Browse for results");

   if (ofn.DoModal() == IDOK)
   {
      // get view to do the work
      m_view.LoadResults(ofn.m_szFileName);
   }
   return 0;
}

// the user wants to save this data
LRESULT CMainFrame::OnSaveResults(WORD, WORD, HWND, BOOL&)
{
   // determine if there are any results
	CTreeViewCtrl tv;
   tv = m_view.GetDlgItem(IDC_TREEDATA);
   int count;
   count = tv.GetCount();
   if (count == 0)
      return 0;

   CFileDialog ofn(FALSE, _T("txt"), NULL, 
      OFN_EXTENSIONDIFFERENT | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST, 
      _T("Results\0*.txt\0All Files\0*.*\0"), this->m_hWnd);   
   ofn.m_ofn.lpstrTitle = _T("Results Filename");

   if (ofn.DoModal() == IDOK)
   {
      // get view to do the work
      m_view.SaveResults(ofn.m_szFileName);
   }
   return 0;
}

// got some free time? then decide what the menu and toolbar items should
// look like
void CMainFrame::UpdateUIAll()
{
	CTreeViewCtrl tv;
   tv = m_view.GetDlgItem(IDC_TREEDATA);
   if (tv == NULL) return;
   UINT count = tv.GetCount();
   UIEnable(ID_FILE_SAVERESULTS, count > 0);
   UIEnable(ID_VIEW_CLEARALL, count > 0);
   UIUpdateToolBar();
}

// initialize the window
LRESULT CMainFrame::OnCreate(UINT, WPARAM, LPARAM, BOOL&)
{
	// create command bar window
	HWND hWndCmdBar = m_CmdBar.Create(m_hWnd, rcDefault, NULL, ATL_SIMPLE_CMDBAR_PANE_STYLE);
	// atach menu
	m_CmdBar.AttachMenu(GetMenu());
	// load command bar images
	m_CmdBar.LoadImages(IDR_MAINFRAME);
	// remove old menu
	SetMenu(NULL);

	HWND hWndToolBar = CreateSimpleToolBarCtrl(m_hWnd, IDR_MAINFRAME, FALSE, ATL_SIMPLE_TOOLBAR_PANE_STYLE);

	CreateSimpleReBar(ATL_SIMPLE_REBAR_NOBORDER_STYLE);
	AddSimpleReBarBand(hWndCmdBar);
	AddSimpleReBarBand(hWndToolBar, NULL, TRUE);
	// create the status bar
   CreateSimpleStatusBar();
   // attach it to our multi pane status bar object
   m_statusBar.SubclassWindow(m_hWndStatusBar);

   // initialize the panes
	int arrParts[] =
	{
		ID_DEFAULT_PANE,
		ID_PID_PANE
	};
	m_statusBar.SetPanes(arrParts, sizeof(arrParts) / sizeof(int), false);
   m_statusBar.SetPaneText(ID_PID_PANE, _T("0"));

	m_hWndClient = m_view.Create(m_hWnd);

	UIAddToolBar(hWndToolBar);
	UISetCheck(ID_VIEW_TOOLBAR, 1);
	UISetCheck(ID_VIEW_STATUS_BAR, 1);

	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);

   UpdateUIAll();

   return 0;
}

// the user has change the toolbar option
LRESULT CMainFrame::OnViewToolBar(WORD, WORD, HWND, BOOL&)
{
   static BOOL bNew = TRUE;	// initially visible
   bNew = !bNew;
   ::SendMessage(m_hWndToolBar, RB_SHOWBAND, 1, bNew);	// toolbar is band #1
   UISetCheck(ID_VIEW_TOOLBAR, bNew);
   UpdateLayout();
   return 0;
}

// the user has changed the status bar option
LRESULT CMainFrame::OnViewStatusBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
   BOOL bNew = !::IsWindowVisible(m_hWndStatusBar);
   ::ShowWindow(m_hWndStatusBar, bNew ? SW_SHOWNOACTIVATE : SW_HIDE);
   UISetCheck(ID_VIEW_STATUS_BAR, bNew);
   UpdateLayout();
   return 0;
}

LRESULT CMainFrame::OnUpdateStatusbar(UINT, WPARAM wParam, LPARAM, BOOL&)
{
	CTreeViewCtrl tv;
   tv = m_view.GetDlgItem(IDC_TREEDATA);
   if (tv == NULL) return 0;
   int count = tv.GetCount();

   CString str;
   str.Format(_T("%3d"), count);
   m_statusBar.SetPaneText(ID_PID_PANE, str);
   if (wParam == NULL)
      m_statusBar.SetPaneText(ID_DEFAULT_PANE, _T(""));
   else
      m_statusBar.SetPaneText(ID_DEFAULT_PANE, reinterpret_cast<LPTSTR>(wParam));
   return 0;
}
