// aboutdlg.h : interface of the CAboutDlg class
//
/////////////////////////////////////////////////////////////////////////////

// (c) 2000 Richard Grimes, iDevResource.com Ltd
// you are free to use this code as long as your copyright message
// acknowledges iDevResource.com Ltd

#if !defined(AFX_ABOUTDLG_H__1FF3DEE8_D4D4_11D3_8A65_00104BDC35E0__INCLUDED_)
#define AFX_ABOUTDLG_H__1FF3DEE8_D4D4_11D3_8A65_00104BDC35E0__INCLUDED_

#include <winver.h>

// class used to show the about dialog, this illustrates how to use the 
// hyper link control and access version info data
class CAboutDlg : public CDialogImpl<CAboutDlg>
{
public:
	enum { IDD = IDD_ABOUTBOX };
   
   CHyperLink m_hyper;

	BEGIN_MSG_MAP(CAboutDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT, WPARAM, LPARAM, BOOL&)
	{
      // initialize the hyper link
      m_hyper.SetHyperLink(_T("http://www.idevresource.com"));
      m_hyper.SetLabel(_T("www.idevresource.com"));
      // attach the hyper link object to the static control
      m_hyper.SubclassWindow(GetDlgItem(IDC_IDR));

		CenterWindow(GetParent());

      // fill the version
      HRSRC hRs;
      // get version resource
      hRs = FindResource(_Module.GetResourceInstance(), MAKEINTRESOURCE(VS_VERSION_INFO), RT_VERSION);
      if (hRs)
      {
         HGLOBAL hGlobal;
         // load it in global memory
         hGlobal = LoadResource(_Module.GetResourceInstance(), hRs);
         if (hGlobal)
         {
            // lock it so that I can read it
            LPBYTE pb = reinterpret_cast<LPBYTE>(LockResource(hGlobal));
            if (pb)
            {
               WORD* vi = reinterpret_cast<WORD*>(pb);
               if (vi[1] > 0)
               {
                  // access the fixed version info
                  VS_FIXEDFILEINFO* ffi = reinterpret_cast<VS_FIXEDFILEINFO*>(pb + 4 * sizeof(WORD) + 16 * sizeof(WCHAR));
                  CString str;
                  str.Format(_T("v%d.%d.%d.%d"),
                     HIWORD(ffi->dwProductVersionMS), LOWORD(ffi->dwProductVersionMS),
                     HIWORD(ffi->dwProductVersionLS), LOWORD(ffi->dwProductVersionLS));

                  // write it to the static on the dialog
                  CStatic stat;
                  stat = GetDlgItem(IDC_VERSION);
                  stat.SetWindowText(str);
               }
            }
         }
      }
		return TRUE;
	}

	LRESULT OnCloseCmd(WORD, WORD wID, HWND, BOOL&)
	{
		EndDialog(wID);
		return 0;
	}
};

#endif // !defined(AFX_ABOUTDLG_H__1FF3DEE8_D4D4_11D3_8A65_00104BDC35E0__INCLUDED_)
