// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

// (c) 2000 Richard Grimes, iDevResource.com Ltd
// you are free to use this code as long as your copyright message
// acknowledges iDevResource.com Ltd

#if !defined(AFX_MAINFRM_H__1FF3DEE9_D4D4_11D3_8A65_00104BDC35E0__INCLUDED_)
#define AFX_MAINFRM_H__1FF3DEE9_D4D4_11D3_8A65_00104BDC35E0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// This is the frame class. It is used to handle menu and toolbar
// messages
class CMainFrame : 
   public CFrameWindowImpl<CMainFrame>, 
   public CUpdateUI<CMainFrame>,
   public CMessageFilter, 
   public CIdleHandler
{
public:
	DECLARE_FRAME_WND_CLASS(NULL, IDR_MAINFRAME)

	CDebugInfoView m_view;
	CCommandBarCtrl m_CmdBar;
   CMultiPaneStatusBarCtrl m_statusBar;

   CMainFrame() : m_view(this)
   {}

   // Should use BEGIN_MSG_MAP_EX() for the message map because it uses message crackers
   // but this screws up classview. Instead, declared the functions by hand
	BOOL m_bATL3MsgHandled; 
	BOOL IsMsgHandled() const 
	{ 
		return m_bATL3MsgHandled; 
	} 
	void SetMsgHandled(BOOL bHandled) 
	{ 
		m_bATL3MsgHandled = bHandled; 
	} 

	BEGIN_MSG_MAP(CMainFrame)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_UPDATESB, OnUpdateStatusbar)
		MSG_WM_CLOSE(OnClose)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)
		COMMAND_ID_HANDLER(ID_VIEW_CLEARALL, OnClearAll)
		COMMAND_ID_HANDLER(ID_APP_EXIT, OnExit)
		COMMAND_ID_HANDLER(ID_FILE_STARTPROCESS, OnStartProcess)
		COMMAND_ID_HANDLER(ID_FILE_SAVERESULTS, OnSaveResults)
		COMMAND_ID_HANDLER(ID_FILE_OPENRESULTS, OnOpenResults)
		COMMAND_ID_HANDLER(ID_VIEW_TOOLBAR, OnViewToolBar)
		COMMAND_ID_HANDLER(ID_VIEW_STATUS_BAR, OnViewStatusBar)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)
		CHAIN_MSG_MAP(CUpdateUI<CMainFrame>)
		CHAIN_MSG_MAP(CFrameWindowImpl<CMainFrame>)
	END_MSG_MAP()

	BEGIN_UPDATE_UI_MAP(CMainFrame)
      UPDATE_ELEMENT(ID_FILE_SAVERESULTS,  UPDUI_MENUPOPUP | UPDUI_TOOLBAR)
      UPDATE_ELEMENT(ID_VIEW_CLEARALL,  UPDUI_MENUPOPUP | UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_VIEW_TOOLBAR, UPDUI_MENUPOPUP)
		UPDATE_ELEMENT(ID_VIEW_STATUS_BAR, UPDUI_MENUPOPUP)
	END_UPDATE_UI_MAP()

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnIdle();

	LRESULT OnCreate(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnUpdateStatusbar(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnClose();
	LRESULT OnAppAbout(WORD, WORD, HWND, BOOL&);
	LRESULT OnExit(WORD, WORD, HWND, BOOL&);
   LRESULT OnClearAll(WORD, WORD, HWND, BOOL&);
   LRESULT OnStartProcess(WORD, WORD, HWND, BOOL& bHandled);
   LRESULT OnOpenResults(WORD, WORD, HWND, BOOL& bHandled);
   LRESULT OnSaveResults(WORD, WORD, HWND, BOOL& bHandled);
	LRESULT OnViewToolBar(WORD, WORD, HWND, BOOL&);
	LRESULT OnViewStatusBar(WORD, WORD, HWND, BOOL&);

private:
   void UpdateUIAll();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__1FF3DEE9_D4D4_11D3_8A65_00104BDC35E0__INCLUDED_)
